KeyProfiler2 = LibStub("AceAddon-3.0"):NewAddon("KeyProfiler2", "AceConsole-3.0", "AceEvent-3.0", "AceTimer-3.0")

local ldb = LibStub:GetLibrary("LibDataBroker-1.1")
local QTC = LibStub('LibQTip-1.0')
local LDBicon = LibStub("LibDBIcon-1.0")

--Globals
local LDBHtext = ""

--Various Draw LDB Display Tooltip Functions
local function HideTooltip()
	if not tooltip then return end
	if tooltip and MouseIsOver(tooltip) then return end
	tooltip:SetScript("OnLeave", HideTooltip)
	tooltip:Hide()
	QTC:Release(tooltip)
	tooltip = nil
end

local function ProfilesHandler( cell, arg, button)       
  local name = arg
  if button == "LeftButton" then
    if IsShiftKeyDown() then      
      if name then     
       --Create PopUp for Profile OVERWRITE Confirm
        StaticPopupDialogs["KP_CONFIRM_OWRITE1"] = {
			  text = "Are You Sure you Want To OVERWRITE |cffff9933" .. name .. "|r KeyProfile?", button1 = "OK", button2 = "Cancel",
			  OnAccept = function()
			 	  if name then    
            KeyProfiler2:SaveBindings(name)          
            KeyProfiler2.db.profile.settings.loaded = name
            KeyProfiler2:RefreshTT()
            KeyProfiler2:Print("|cffff9933Updated Current KeyBindings SnapShot to Profile: |r" .. "|cff66ffff " .. name .. "|r")
          end
		    end,		
			   timeout = 0, whileDead = 1, hideOnEscape = 1
		    }
		    StaticPopup_Show("KP_CONFIRM_OWRITE1");
		    return        
      end
    else
      if name then
        KeyProfiler2.db.profile.settings.loaded = name
        KeyProfiler2:LoadBindings(name)
        KeyProfiler2:RefreshTT() 
      end
    end
  elseif button == "RightButton" then
    if IsAltKeyDown() and IsControlKeyDown() then      
     --Create PopUp for Profile DELETE Confirm
      StaticPopupDialogs["KP_CONFIRM_DEL1"] = {
			text = "Are You Sure you Want To DELETE |cffff9933" .. name .. "|r KeyProfile?", button1 = "OK", button2 = "Cancel",
			OnAccept = function()
			 	if name then    
          KeyProfiler2:DeleteBinding(name)         	
	        KeyProfiler2:RefreshTT()
	        KeyProfiler2:Print("|cff993333Deleted |r".."|cffffff00 ".. name .."|r Profile From ".."|cff66ff33DataBase!!!|r")	           
        end
		  end,		
			 timeout = 0, whileDead = 1, hideOnEscape = 1
		  }
		  StaticPopup_Show("KP_CONFIRM_DEL1");
		  return       
    end 
  end  
end

local function LoadHandler( cell, arg, button)       
  if arg == "b1" then  
    KeyProfiler2:ToggleDSpec()
    KeyProfiler2:RefreshTT() 
  elseif arg == "b2" then   
    KeyProfiler2:ToggleForced()
    KeyProfiler2:RefreshTT() 
  end  
end

local function SaveHandler( cell, arg, button)       
  if arg == "b1" then  
    KeyProfiler2:KPPopUP()
    KeyProfiler2:RefreshTT()
  end  
end

local function DrawTooltip()    
    tooltip:Hide()
    if tooltip then    
      tooltip:Clear()
    end
    KeyProfiler2:RefreshLDBTT()     
    local headerFont = CreateFont("KeyProfiler2HeaderFont")
	    KeyProfiler2HeaderFont:CopyFontObject(GameTooltipHeaderText)
	    KeyProfiler2HeaderFont:SetFont(KeyProfiler2HeaderFont:GetFont(), 15)    
    local y = tooltip:AddLine()
	    tooltip:SetCell(y, 1, "|cffff9933 KeyProfiler2 |r",KeyProfiler2HeaderFont, "CENTER", 1)     
    local y = tooltip:AddLine()
	    tooltip:SetCell(y, 1, "", "CENTER", 1)
    local y = tooltip:AddLine()
	    tooltip:SetCell(y, 1, "", "CENTER", 1)
	    tooltip:SetLineColor(y, 0, 0, 1, 1)
	  local y = tooltip:AddLine()
	    tooltip:SetCell(y, 1, "", "CENTER", 1)
	    tooltip:SetLineColor(y, 0, 0, 1, 1)    
    local y = tooltip:AddLine()
      tooltip:SetCell(y, 1, "|cffffff00Loaded KeyProfile:|r".."|cff66ffff ".. KeyProfiler2:LDBTT() .."|r", "CENTER", 1)
    if KeyProfiler2.db.profile.settings.loaded then
      tooltip:SetCellColor(y, 1, 0, 1, 0, 0.5)
    elseif not KeyProfiler2.db.profile.settings.loaded or KeyProfiler2.db.profile.settings.loaded == nil then
      tooltip:SetCellColor(y, 1, 1, 0, 0, 0.5)
    end
    local y = tooltip:AddLine()
	    tooltip:SetCell(y, 1, "", "CENTER", 1)
    local y = tooltip:AddLine()
	    tooltip:SetCell(y, 1, "", "CENTER", 1)
	    tooltip:SetLineColor(y, 0, 0, 1, 1)
	  local y = tooltip:AddLine()
	    tooltip:SetCell(y, 1, "", "CENTER", 1)
	    tooltip:SetLineColor(y, 0, 0, 1, 1)
      tooltip:SetCell(y, 1, "|cffccffffConfigurations|r", "CENTER", 1)
    local y = tooltip:AddLine()
	    tooltip:SetCell(y, 1, "", "CENTER", 1)
    local y = tooltip:AddLine()
	    tooltip:SetCell(y, 1, "", "CENTER", 1)
	    tooltip:SetLineColor(y, 0, 0, 1, 1)
	  local y = tooltip:AddLine()
	    tooltip:SetCell(y, 1, "", "CENTER", 1)
	    tooltip:SetLineColor(y, 0, 0, 1, 1)  
    local y = tooltip:AddLine()
      tooltip:SetCell(y, 1, "|cffcc99ffQuick KeyBind Profile Actions|r", "CENTER", 1)     
    local y = tooltip:AddLine()
	    tooltip:SetCell(y, 1, "", "CENTER", 1)	       
    local y = tooltip:AddLine()      
      if KeyProfiler2.db.profile.settings.dualspec then
        y = tooltip:SetCell(y, 1, "|cffffff33Click for DuelSpec Support|r", "CENTER", 1)
        tooltip:SetCellScript( y, 1, "OnMouseDown", LoadHandler, "b1" )
      elseif not KeyProfiler2.db.profile.settings.dualspec then
        y = tooltip:SetCell(y, 1, "|cff66cc66 Click for DuelSpec Support|r", "CENTER", 1)
        tooltip:SetCellScript( y, 1, "OnMouseDown", LoadHandler, "b1" )     
      end     
      if KeyProfiler2.db.profile.settings.dualspec then
        tooltip:SetCellColor(y, 1, 0, 1, 0, 1)
      elseif not KeyProfiler2.db.profile.settings.dualspec then
        tooltip:SetCellColor(y, 1, 1, 0, 0, 0.4)
      end      
    local y = tooltip:AddLine()
	    tooltip:SetCell(y, 1, "", "CENTER", 1)
    local y = tooltip:AddLine()
	    tooltip:SetCell(y, 1, "", "CENTER", 1)
    local y = tooltip:AddLine()
      if KeyProfiler2.db.profile.settings.forced then
        y = tooltip:SetCell(y, 1, "|cffffff33 Click to ForceBindings|r", "CENTER", 1)
        tooltip:SetCellScript( y, 1, "OnMouseDown", LoadHandler, "b2" )
      elseif not KeyProfiler2.db.profile.settings.forced then
        y = tooltip:SetCell(y, 1, "|cff66cc66 Click to ForceBindings|r", "CENTER", 1)
        tooltip:SetCellScript( y, 1, "OnMouseDown", LoadHandler, "b2" )
      end
      if KeyProfiler2.db.profile.settings.forced then
        tooltip:SetCellColor(y, 1, 0, 1, 0, 1)
      elseif not KeyProfiler2.db.profile.settings.forced then
        tooltip:SetCellColor(y, 1, 1, 0, 0, 0.4)
      end
    local y = tooltip:AddLine()
	    tooltip:SetCell(y, 1, "", "CENTER", 1)
    local y = tooltip:AddLine()
	    tooltip:SetCell(y, 1, "", "CENTER", 1)
	    tooltip:SetLineColor(y, 0, 0, 1, 1)
	  local y = tooltip:AddLine()
	    tooltip:SetCell(y, 1, "", "CENTER", 1)
	    tooltip:SetLineColor(y, 0, 0, 1, 1)
    local y = tooltip:AddLine()
      tooltip:SetCell(y, 1, "|cffcc99ffSaved KeyBinds Profile Names|r", "CENTER", 1)  
    local y = tooltip:AddLine()
	    tooltip:SetCell(y, 1, "", "CENTER", 1)	  
    for k,v in pairs(KeyProfiler2.db.profile.bindings) do
			local y, x = tooltip:AddLine()
			  tooltip:SetCell(y, 1, "Load" .. "|cff66ffff " .. k .. "|r KeyProfile", "CENTER", 1)
			  tooltip:SetCellScript( y, 1, "OnMouseDown", ProfilesHandler, k )
			  tooltip:SetCellColor(y, 1, 1, 1, 0, 0.5)
			local y = tooltip:AddLine()
        tooltip:SetCell(y, 1, "", "CENTER", 1)
		end
		local y = tooltip:AddLine()
	    tooltip:SetCell(y, 1, "", "CENTER", 1)
	  local y = tooltip:AddLine()
	    tooltip:SetCell(y, 1, "", "CENTER", 1)
	    tooltip:SetLineColor(y, 0, 0, 1, 1)
	  local y = tooltip:AddLine()
	    tooltip:SetCell(y, 1, "", "CENTER", 1)
	    tooltip:SetLineColor(y, 0, 0, 1, 1)
		local y, x = tooltip:AddLine()
			tooltip:SetCell(y, 1, "|cffffff00Save a |r" .. "|cff66ffffKeyProfile |r", "CENTER", 1)
			tooltip:SetCellScript( y, 1, "OnMouseDown", SaveHandler, "b1" )
		  tooltip:SetCellColor(y, 1, 1, 0, 0, 0.4)
		local y = tooltip:AddLine()
	    tooltip:SetCell(y, 1, "", "CENTER", 1)
    local y = tooltip:AddLine()
	    tooltip:SetCell(y, 1, "", "CENTER", 1)
	    tooltip:SetLineColor(y, 0, 0, 1, 1)
	  local y = tooltip:AddLine()
	    tooltip:SetCell(y, 1, "", "CENTER", 1)
	    tooltip:SetLineColor(y, 0, 0, 1, 1)
		local y = tooltip:AddLine()
      tooltip:SetCell(y, 1, "|cffff9933 Click Profile to Load Saved KeyBinds |r", "CENTER", 1)   
    local y = tooltip:AddLine()
      tooltip:SetCell(y, 1, "|cffff9933 Shift+LeftClick Profile Updates to Current KeyBinds |r", "CENTER", 1)
    local y = tooltip:AddLine()
      tooltip:SetCell(y, 1, "|cffff9933 Ctrl+Alt+RightClick Profile to Remove from DataBase |r", "CENTER", 1)   
    local y = tooltip:AddLine()
      tooltip:SetCell(y, 1, "", "CENTER", 1)
    local y = tooltip:AddLine()
	    tooltip:SetCell(y, 1, "", "CENTER", 1)
	    tooltip:SetLineColor(y, 0, 0, 1, 1)
    local y = tooltip:AddLine()
	    tooltip:SetCell(y, 1, "", "CENTER", 1)
	    tooltip:SetLineColor(y, 0, 0, 1, 1)             				
    tooltip:UpdateScrolling(600)
    tooltip:Show()	
end

--DB Defaults
local defaults = {
	profile = {
	   settings = {
	     LibDBIcon = { hide = false },
	   },
	 	 bindings = {},
	 	 defaultsave = 0,  	
	},
}
-- Options table
KeyProfiler2.settings = {
 type = "group",
 name = "Settings",
 desc = "Settings for KeyProfiler2",
 args = {
 	 minimapButton = {
 		type = "toggle",
 		name = "Minimap Button",
 		desc = "Enable/Disable the Minimap Button.", 		
 		get = function() return not KeyProfiler2.db.profile.settings.LibDBIcon.hide end,
	  set = function(self, v)
		    KeyProfiler2.db.profile.settings.LibDBIcon.hide = not v
				  if v then
					  LDBicon:Show("KeyProfiler2")
				  else
					  LDBicon:Hide("KeyProfiler2")
				  end
			end,
	 }, 		
 }
}
KeyProfiler2.options = {
	type = "group",
	name = "KeyProfiler",
	desc = "Options for KeyProfiler",
	args = {		
	  AddProfiles = {
	    order = 1,			    
			type = "group",
			inline = true,
			name = "Save Profile",
			desc = "Save Current KeyBindings to a Profile.",
			args = {
			   addSaveText = {
		       type = "header",
		       name = "Save the Current KeyBindings to a Profile Name.",
			     order = 1
		     },	
		     addProfile = {
			     order = 2,
			     type = "input",						
			     name = "SnapShot Current KeyBindings",
			     desc = "Save the Current KeyBindings to a Profile Name",
			     width = 'full',
			     get = false,
			     set = function(self, v) KeyProfiler2:SaveBindings(v); end,			
			     usage = "<name for the bindings>"
		     },			   
			},
	  },
	  KBindsText1 = {
		  type = "header",
		  name = "KeyBindings Tool.",
		  order = 2
		},
		KBinds = {
			order = 3,
		  type = 'execute',
		  name = "KeyBindings",			
			desc = "Open your Keybindings Interface",
			width = 'full',
			func = function()			  
			   KeyProfiler2:ToggleKBF()		
			 end  
		},
		KBindsText2 = {
		  type = "header",
		  name = "",
		  width = 'full',
		  order = 4
		},
		addProfilesText = {
		  type = "header",
		  name = "",
			order = 5
		},
		loadProfile = {
			order = 6,
			type = "group",			
			name = "Keybinds Profiles",
			desc = "Profiles that can be loaded",
			args = {			
				load = {	
				  type = "select",
				  name = "Load",
					desc = "Load a profile",
					order = 1,
					get = function() return KeyProfiler2.db.profile.settings.loaded; end,
					set = function(self, v) KeyProfiler2.db.profile.settings.loaded = v; KeyProfiler2:LoadBindings(v); end,
					values = {}
				},
				delete = {	
				  type = "select",
					name = "Delete",
					desc = "Delete a profile",
					order = 2,
					get = function() return KeyProfiler2.db.profile.settings.loaded; end,
					set = function(self, v) KeyProfiler2:DeleteBinding(v); end,
					values = {}
				},
				forceUpdate = {
				  order = 3,
 		      type = "toggle",
 		      name = "Force KeyBinds",
 		      desc = "Enable/Disable Forced Overwritting of all KeyBinds when applying new KeyBind Profiles.",
 		      get = function() return KeyProfiler2.db.profile.settings.forced end,
 		      set = function() 
 		          KeyProfiler2.db.profile.settings.forced = not KeyProfiler2.db.profile.settings.forced 		    
 		        end,
 	      },			
			},			
		},
		loadProfile2 = {
			order = 7,
			type = "group",			
			name = "DualSpec Profiles",
			desc = "Profiles that can be loaded on DualSpec Switching.",
			args = {
			  loadP = {	type = "select",
					name = "Primary",
					order = 1,
					desc = "Load a Profile On Primary Talent Switch",
					get = function() return KeyProfiler2.db.profile.settings.loadedP; end,
					set = function(self, v) 
							KeyProfiler2.db.profile.settings.loadedP = v;									
						end,
					disabled = function()					                    
					      return not KeyProfiler2.db.profile.settings.dualspec 					                   
					   end,
					values = {}					
				},
				loadS = {	
				  type = "select",
					name = "Secondary",
					order = 2,
					desc = "Load a Profile On Secondary Talent Switch.",
					get = function() return KeyProfiler2.db.profile.settings.loadedS; end,
					set = function(self, v) 
							KeyProfiler2.db.profile.settings.loadedS = v;									
						end,
					disabled = function()					                    
					      return not KeyProfiler2.db.profile.settings.dualspec 					                   
					   end,
					values = {}
				},
				enableDS = {
				  order = 3,
 		      type = "toggle",
 		      name = "DualSpec",
 		      desc = "Enable/Disable DualSpec Profile Support.",
 		      get = function() return KeyProfiler2.db.profile.settings.dualspec end,
 		      set = function() 
 		          KeyProfiler2.db.profile.settings.dualspec = not KeyProfiler2.db.profile.settings.dualspec 		    
 		        end,
 	      },			
				forceUpdate2 = {
				  order = 4,
 		      type = "toggle",
 		      name = "Force KeyBinds",
 		      desc = "Enable/Disable Forced Overwritting of all KeyBinds when applying new KeyBind Profiles.",
 		      get = function() return KeyProfiler2.db.profile.settings.forced end,
 		      set = function() 
 		          KeyProfiler2.db.profile.settings.forced = not KeyProfiler2.db.profile.settings.forced 		    
 		        end,
 		      disabled = function()					                    
					      return not KeyProfiler2.db.profile.settings.dualspec 					                   
					   end
 	      },			
			},
	  },
	  loadProfile3 = {
			order = 8,
			type = "group",
			name = "DataBase Tools",
			desc = "Tools for DataBase Manipualtion.",
			args = {
			  addDBToolsText = {
		      type = "header",
		      name = "Optional DataBase Tools.",
			    order = 1
		    },
		    dbReset = {
			    order = 2,
		      type = 'execute',
		      name = "Reset Entire DB",
		      width = 'double',
			    desc = "Deletes ALL SnapShot Profiles from this Character. This Causes A Reload of your Interface",
			    func = function()			    
			       StaticPopupDialogs["KP_CONFIRM_DBRESET"] = {
			       text = "Are You Sure you Want To ".."|cffff9933RESET|r ".." DataBase?  ".."|cffff3366THIS WILL FORCE A UI RELOAD!!|r", button1 = "OK", button2 = "Cancel",
			       OnAccept = function()
			 	       KeyProfiler2:ResetKDB()
		         end,
			       timeout = 0, whileDead = 1, hideOnEscape = 1
		         }
		         StaticPopup_Show("KP_CONFIRM_DBRESET");
		         return			      
			     end,
		    },
			},
	  },
	},
}

-- Scan local Bindings... thanks to nymbia (copied from SpellBinder)
local bindables = {
	'ESCAPE', "`", 'TAB', 'SPACE', 'Q', 'W', 'E', 'R', 'T', 'Y', 'U', 'I', 'O', 'P', 'A', 'S',
	'D', 'F', 'G', 'H', 'J', 'K', 'L', 'Z', 'X', 'C', 'V', 'B', 'N', 'M', '-', '=', '[', ']',
	'\\', ';', "'", '.', '/', ',','#', '^', '','', '', 'ENTER', 'MOUSEWHEELUP', 'MOUSEWHEELDOWN', 'BACKSPACE', 'DELETE',
	'INSERT', 'HOME', 'END', 'PAGEUP', 'PAGEDOWN', 'NUMLOCK', 'NUMPADSLASH', 'NUMPADMULTIPLY', 'NUMPADMINUS',
	'NUMPADPLUS', 'NUMPADENTER', 'NUMPADPERIOD',
}
for i = 0, 9 do
	bindables[#bindables+1] = tostring(i)
	bindables[#bindables+1] = 'NUMPAD'..i
end
for i = 1, 12 do
	bindables[#bindables+1] = 'F'..i
end
for i = 1, 5 do
	bindables[#bindables+1] = 'BUTTON'..i
end
local modifiers = {
	'', 'ALT-', 'CTRL-', 'SHIFT-', 'ALT-CTRL-', 'ALT-SHIFT-', 'CTRL-SHIFT-', 'ALT-CTRL-SHIFT-'
}

function KeyProfiler2:AddBindings()
	if KeyProfiler2.db.profile.bindings then
		for k,v in pairs(KeyProfiler2.db.profile.bindings) do
			KeyProfiler2.options.args.loadProfile.args.load.values[k] = k
			KeyProfiler2.options.args.loadProfile2.args.loadP.values[k] = k
			KeyProfiler2.options.args.loadProfile2.args.loadS.values[k] = k
			KeyProfiler2.options.args.loadProfile.args.delete.values[k] = k					
		end		
	end
end

--Initialize our Addon
function KeyProfiler2:OnInitialize()
  self.db = LibStub("AceDB-3.0"):New("KeyProfiler2DB", defaults)
  LibStub("AceConfig-3.0"):RegisterOptionsTable("KeyProfiler", self.options)
	self.optionsFrame = LibStub("AceConfigDialog-3.0"):AddToBlizOptions("KeyProfiler", "KeyProfiler")
	LibStub("AceConfig-3.0"):RegisterOptionsTable("KeyProfiler-Settings", self.settings)
	self.settingsFrame = LibStub("AceConfigDialog-3.0"):AddToBlizOptions("KeyProfiler-Settings", "Settings", "KeyProfiler")
	LibStub("AceConfig-3.0"):RegisterOptionsTable("KeyProfiler-Profiles", LibStub("AceDBOptions-3.0"):GetOptionsTable(self.db))
	self.profilesFrame = LibStub("AceConfigDialog-3.0"):AddToBlizOptions("KeyProfiler-Profiles", "Profiles", "KeyProfiler")
	  		
  local	dataobject = ldb:NewDataObject("KeyProfiler2", 
       {type = "data source", icon = [[Interface\Icons\Spell_Nature_Slow]], 
      OnClick = function(frame, button) 
        if button == "RightButton" then
				  InterfaceOptionsFrame_OpenToCategory(KeyProfiler2.optionsFrame)
			  elseif button == "LeftButton" then
			    KeyProfiler2:ToggleKBF()			          
        end                  
      end,
      OnEnter = function(frame)
				tooltip = QTC:Acquire("KeyProfilerTooltip", 1, "CENTER")				
				tooltip:SmartAnchorTo(frame)
				tooltip:SetAutoHideDelay(1.25, frame)
				KeyProfiler2:LDBTT()
				DrawTooltip()	    				
			end,
		  OnLeave = function()
				HideTooltip()
			end,
      label = "KeyProfiler2"})  
    
    if LDBicon then
		  LDBicon:Register("KeyProfiler2", dataobject, KeyProfiler2.db.profile.settings.LibDBIcon)
	  end
 
		self:AddBindings()
	  self:RegisterEvent("PLAYER_ENTERING_WORLD", "DelayLoad")
	  
	  if not IsAddOnLoaded("myBindings2") then
       self:CreateGameMenuButtonFrame()
    end
end

--Reset Entire DB
function KeyProfiler2:ResetKDB()
   if KeyProfiler2.db.profile.bindings then
     KeyProfiler2.db.profile.bindings = {}; 
     KeyProfiler2.db.profile.settings.loaded = nil;
     KeyProfiler2.db.profile.defaultsave = nil
   end   
   ReloadUI();   
end

--Delayed Functions
function KeyProfiler2:DelayLoad()
  self:ScheduleTimer("CheckSpec", 65)
  self:ScheduleTimer("CreateDefaults", 45)
end 

--Auto Create Default KeyProfile
function KeyProfiler2:CreateDefaults()
   if not self.db.profile.settings then
			self.db.profile.settings = { minimap = true }
	 end
	 if not self.db.profile.bindings then
			self.db.profile.bindings = {}
	 end
   if not self.db.profile.defaultsave or self.db.profile.defaultsave == 0 then
		  local pname = "Defaults"		 	  
		   KeyProfiler2:SaveBindings(pname)
		   KeyProfiler2:Print("|cff993333Created SnapShot |r".."|cffffff00of your Current KeyBindings ".."|cff66ff33and saved them to the Defaults Profile DataBase!!!|r")
		   self.db.profile.defaultsave = 1		
	 end
end

--hook KeyBinings GameMenu Button
function KeyProfiler2:CreateGameMenuButtonFrame()
	self.defaultmenuonclickhandler = GameMenuButtonKeybindings:GetScript("OnClick")
	 GameMenuButtonKeybindings:SetScript("OnClick", function() 
	   PlaySound("igMainMenuOption");
	   KeyBindingFrame_LoadUI();	
	   ShowUIPanel(KeyBindingFrame)
	   self:CreateButton()
	 end)
end

--Various Talent Spec Functions
local current_talents
function KeyProfiler2:CheckSpec()   
  current_talents = GetActiveTalentGroup()
	KeyProfiler2:RegisterEvent("PLAYER_TALENT_UPDATE")
	if not (current_talents == 1 and 
				KeyProfiler2.db.profile.settings.loaded == KeyProfiler2.db.profile.settings.loadedP)
			and not (current_talents == 2 and 
				KeyProfiler2.db.profile.settings.loaded == KeyProfiler2.db.profile.settings.loadedS) then
		current_talents = nil
		KeyProfiler2:PLAYER_TALENT_UPDATE()
	end   
end

function KeyProfiler2:PLAYER_TALENT_UPDATE()
	local new_talents = GetActiveTalentGroup()
	if new_talents ~= current_talents then
		if KeyProfiler2.db.profile.settings.dualspec then
			if new_talents == 1 and KeyProfiler2.db.profile.settings.loadedP then
		    KeyProfiler2:KPCPPopUP()
			elseif new_talents == 2 and KeyProfiler2.db.profile.settings.loadedS then
        KeyProfiler2:KPCSPopUP()
			else
				self:Print("No DualSpec Support Detected!!!")
				self:Print("Aborting KeyProfiler DualSpec KeyBinds Swapping!!!")
			end
		end
		current_talents = new_talents
	end
end

-- Various Core Functions
function KeyProfiler2:ClearBinds()
	for _, key in ipairs(bindables) do
		for _, modifier in ipairs(modifiers) do
			SetBinding(modifier..key)
		end
	end
end

function KeyProfiler2:DeleteBinding(name)
	name = tostring(name)
	if self.db.profile.settings.loaded == name then self.db.profile.settings.loaded = nil; end
	self.db.profile.bindings[name] = nil
	self.options.args.loadProfile.args.load.values[name] = nil
	self.options.args.loadProfile2.args.loadP.values[name] = nil
	self.options.args.loadProfile2.args.loadS.values[name] = nil
	self.options.args.loadProfile.args.delete.values[name] = nil	
	if _G["KeyProfiler"..name..name] then
	  _G["KeyProfiler"..name..name]:Hide()
	end	
end

function KeyProfiler2:SaveBindings(name)
	name = tostring(name)
	local command, key1, key2
	if self.db.profile.bindings[name] then self:DeleteBinding(name) end
	self.db.profile.bindings[name] = {}
	for _, key in ipairs(bindables) do
		for _, modifier in ipairs(modifiers) do
			local action = GetBindingAction(modifier..key)
			if action and action ~= "" then
				self.db.profile.bindings[name][action] = modifier..key
			end
		end
	end
	KeyProfiler2.options.args.loadProfile.args.load.values[name] = name
	KeyProfiler2.options.args.loadProfile2.args.loadP.values[name] = name
	KeyProfiler2.options.args.loadProfile2.args.loadS.values[name] = name
	KeyProfiler2.options.args.loadProfile.args.delete.values[name] = name
	KeyProfiler2:RefreshLDBTT() 	
end

function KeyProfiler2:LoadBindings(name)
	if InCombatLockdown() then
		self:Print("Cannot bind keys while in combat")
		return
	end

	if self.db.profile.bindings[name] then	  
	  if self.db.profile.settings.forced then
	    if not self.db.profile.bindings[name] then
	      self:Print("Cannot Find Any Saved KeyBindings For this Character, aborting KeyBinds Wipe at this time......")	      
	    else 
	      if self.db.profile.bindings[name] and self.db.profile.settings.forced then
	        self:ClearBinds()
	      end
	    end
	  end
	  
	  if not self.db.profile.bindings[name] then
	    self:Print("Cannot Find Any Saved KeyBindings For this Character, aborting......")
	  elseif self.db.profile.bindings[name] then
	    for k, v in pairs(self.db.profile.bindings[name]) do
		    SetBinding(v, k)
	    end
	    SaveBindings(GetCurrentBindingSet())
	    self:Print("Keybindings have been successfully updated!")
	  end	  
	end  
		
	if self.db.profile.settings.loaded then
	  self:Print(" Loaded: ".."|cff3399cc"..self.db.profile.settings.loaded.."|r Profile. ")	
	end			
end

--Create Tooltip Functions
 -- LDB QTip Fuctions
function KeyProfiler2:RefreshLDBTT()
  if not self.db.profile.settings.loaded then
	  LDBHtext = "|cff66ffffNo Profiles Saved or Loaded|r"
	elseif self.db.profile.settings.loaded then
	  LDBHtext = self.db.profile.settings.loaded
	end	
end

function KeyProfiler2:RefreshTT()
  if tooltip then 
    DrawTooltip()
    KeyProfiler2:RefreshLDBTT()
  end
end

function KeyProfiler2:LDBTT()
  return LDBHtext
end

function KeyProfiler2:SKPBTT()
  GameTooltip:SetOwner(this, "ANCHOR_RIGHT")	
	GameTooltip:AddLine("|cff00ff00Save Currently Bound KeysBindings |r")  
  GameTooltip:AddLine("|cff00ff00 to a KeyProfile Name:|r") 
  GameTooltip:AddLine("|cffff3300   Usage: < name  > ") 
  GameTooltip:AddLine("|cff66ffffType Name of Existing KeyProfile to |r")
	GameTooltip:AddLine("|cff66ffff Overwrite with Currently Saved KeyBindings|r")
	GameTooltip:Show()    
end

function KeyProfiler2:HKPBTT()     	
   GameTooltip:Hide()
end

--Create Tooltip Toggels
 --Various LDB ToolTip Options Toggels
function KeyProfiler2:ToggleKBF()
   PlaySound("igMainMenuOption");
	 KeyBindingFrame_LoadUI();	 
	 if IsAddOnLoaded("myBindings2") then
	    if not myBindings2OptionsFrame:IsShown() then	    
			  myBindings2OptionsFrame:Show()
			else
			  myBindings2OptionsFrame:Hide()
			end
			if InterfaceOptionsFrame:IsShown() then
			   InterfaceOptionsFrame:Hide()
			end
	 else
			if not KeyBindingFrame:IsShown() then	    
			  KeyBindingFrame:Show()
			  KeyProfiler2:CreateButton()
			else
			  KeyBindingFrame:Hide()
			end	
			if InterfaceOptionsFrame:IsShown() then
			   InterfaceOptionsFrame:Hide()
			end			
	 end	
end

function KeyProfiler2:ToggleForced()
   if KeyProfiler2.db.profile.settings.forced then   
     KeyProfiler2.db.profile.settings.forced = nil 
      KeyProfiler2:Print("|cff3399ccForced KeyBinds: |r" .. "|cffff0033Disabled!!!|r")      
   elseif not KeyProfiler2.db.profile.settings.forced then      
     KeyProfiler2.db.profile.settings.forced = true
      KeyProfiler2:Print("|cff3399ccForced KeyBinds: |r" .. "|cff339900Enabled!!!|r")      
   end
end

function KeyProfiler2:ToggleDSpec()
   if KeyProfiler2.db.profile.settings.dualspec then   
     KeyProfiler2.db.profile.settings.dualspec = nil 
      KeyProfiler2:Print("|cff3399ccDuelSpec: |r" .. "|cffff0033Disabled!!!|r")       
   elseif not KeyProfiler2.db.profile.settings.dualspec then      
     KeyProfiler2.db.profile.settings.dualspec = true
      KeyProfiler2:Print("|cff3399ccDuelSpec: |r" .. "|cff339900Enabled!!!|r")      
   end
end

--Create PopUps
--Create KeyBinds Frame Save Profile Button
function KeyProfiler2:CreateButton()
    local KPButton = CreateFrame("Button","KPSToggle",KeyBindingFrame,"UIPanelButtonTemplate")
		local width = KPButton:GetTextWidth() + 10
	    if width < 100 then
		     width = 100
	    end
	  KPButton:SetWidth(width)
	  KPButton:SetHeight(20)
		KPButton:SetText("KeyProfiles")
		KPButton:SetPoint("TOPLEFT", KeyBindingFrame, "TOPLEFT", 10, -10)
		KPButton:SetScript("OnEnter",function()
			KeyProfiler2:SKPBTT()
		end)
	  KPButton:SetScript("OnLeave",function()
			KeyProfiler2:HKPBTT()
		end)
		KPButton:SetScript("OnClick",function()		 
		  KeyProfiler2:KPPopUP()		 					
	 end) 
end

--Create PopUp for KeyBindsFrame Profile Save
function KeyProfiler2:KPPopUP()
    StaticPopupDialogs["KP_GET_PLAYER_NAME"] = {
			text = "Add The SnapShots Profile Name", button1 = "OK", button2 = "Cancel", hasEditBox = 1,
			OnAccept = function()		
				local msg	= getglobal(this:GetParent():GetName().."EditBox"):GetText().." "
				if not msg or msg:trim() == "" then 
				  self:Print("Must Have a Valid Name.")
				  return 
				end				
				KeyProfiler2:SaveBindings(msg)
			end,
			timeout = 0, whileDead = 1, hideOnEscape = 1
		}
		StaticPopup_Show("KP_GET_PLAYER_NAME");
		return		
end

--Create PopUp for Primary Talent Spec Detection
function KeyProfiler2:KPCPPopUP()
    StaticPopupDialogs["KP_CONFIRM_SWAP1"] = {
			text = "Primary Talent Spec Detected, Switching to Primary KeyBinds Profile....    ", button1 = "OK", button2 = "Cancel",
			OnAccept = function()
			 	local name = KeyProfiler2.db.profile.settings.loadedP 
				KeyProfiler2.db.profile.settings.loaded = name				
				KeyProfiler2:LoadBindings(name)
		  end,		
			timeout = 0, whileDead = 1, hideOnEscape = 1
		}
		StaticPopup_Show("KP_CONFIRM_SWAP1");
		return		
end

--Create PopUp for Secondary Talent Spec Detection
function KeyProfiler2:KPCSPopUP()
    StaticPopupDialogs["KP_CONFIRM_SWAP2"] = {
			text = "Secondary Talent Spec Detected, Switching to Secondary KeyBinds Profile....   ", button1 = "OK", button2 = "Cancel",
			OnAccept = function()
			 	local name = KeyProfiler2.db.profile.settings.loadedS 
				KeyProfiler2.db.profile.settings.loaded = name				
				KeyProfiler2:LoadBindings(name)
		  end,		
			timeout = 0, whileDead = 1, hideOnEscape = 1
		}
		StaticPopup_Show("KP_CONFIRM_SWAP2");
		return		
end